package com.maththinking.dbcruiser;
//********************************************************************
//
// EmpBeanTest.java
//
// This example shows how to use JavaBean generated by DB Cruiser.
//
// EmpBean.java is generated by DB Cruiser.
//
// DB Cruiser is a product by:
// MathThinking Technologies, Inc.
// http://www.maththinking.com
//
//*********************************************************************

import java.math.BigDecimal;
import java.sql.*;
import java.util.Date;

public class EmpBeanTest
{
   public static void main(String argv[])
   {
      // Create a new Dept record
      EmpBean empBean = new EmpBean();
      empBean.setEmpno(BigDecimal.valueOf(1234));
      empBean.setEname("John Smith");
      empBean.setJob("Manager");
      empBean.setMgr(BigDecimal.valueOf(5678));
      empBean.setHiredate(new Timestamp((new Date()).getTime()));
      empBean.setSal(BigDecimal.valueOf(60000));
      empBean.setDeptno(BigDecimal.valueOf(30));
      System.out.println(empBean.insertStatement());

      Connection conn = null;
      Statement statement = null;
      ResultSet resultSet = null;
      try {
          // Loca JDBC driver.
          Class.forName("oracle.jdbc.driver.OracleDriver").newInstance();

          // Get database connection.
          String connURL = "jdbc:oracle:thin:@localhost:1521:mathdb";
          conn = DriverManager.getConnection (connURL, "scott", "tiger");

          // Insert the record into the database.
          empBean.insertDatabase(conn);  // insertDatabase(Connection conn) is generated by DB Cruiser.
          System.out.println("Inserted successfully");

          // Get a record from the database.
          String query ="select * from emp where empno=20";
          statement = conn.createStatement();
          resultSet = statement.executeQuery(query);
          if (resultSet.next()) {
              // Set attributes from the ResultSet.
              empBean.setAttributes(resultSet);  // setAttributes(ResultSet rs) is generated by DB Cruiser.
          }
          System.out.println("Employee Number   = "+empBean.getEmpno());
          System.out.println("Employee Name     = "+empBean.getEname());
          System.out.println("Job Title = "+empBean.getJob());
          System.out.println("Manager ID = "+empBean.getMgr());
          System.out.println("Hired Date = "+empBean.getHiredate());
          System.out.println("Salary = "+empBean.getSal());
          System.out.println("Dept No. = "+empBean.getDeptno());

      } catch(Exception e) {
          e.printStackTrace();
      } finally {
          try {
              if (resultSet != null) {
                  resultSet.close();
                  resultSet = null;
              }
              if (statement != null) {
                  statement.close();
                  statement = null;
              }
              if (conn != null) {
                  conn.close();
                  conn = null;
              }
          } catch(Exception e) {
              e.printStackTrace();
          }
      }

   }
}